#include <iostream>

using namespace std;

int main()
{
    unsigned int h,n;
    cin >> h;
    cin >> n;
    unsigned int last = n-1;
    unsigned int brojReda;
    unsigned int matrica[h][n];
    unsigned int dodaj[n];
    unsigned int resenje[n];
    int sveNule = 0;

    /// unos matrice
    for(int i = 0; i < h; i++){
        for (int j = 0; j < n; j++){
            cin >> matrica[i][j];
        }
    }
    /// inicijalizacija resenje i dodaj
    for(int i = 0; i < n; i++){
        resenje[i] = matrica[0][i];
        dodaj[i] = 0;
    }

    for(int j = 0; j < h; j++){
        brojReda  = j;
        for(int i = 0; i < n; i++){
            dodaj[i] = 0;
        }
        sveNule = 0;
        for(int i = 0; i < n; i++){
            if(matrica[brojReda][i] == 0){
                /// cout << "broj reda: " << brojReda << "mesto: " << i << endl;
                sveNule++;
                if(sveNule == n){
                    for(int r = 0; r < n; r++){
                        cout << 0 << " " ;
                    }
                    return 0;
                }
                    if(i == 0){ ///
                        if(brojReda == 0){ ///
                            dodaj[1] += 1; ///
                            resenje[0] = 0;
                        }   ///
                    dodaj[1] += resenje[0]; ///
                    resenje[0] = 0;
                    } ///
                else if(i == last){
                    if(brojReda == 0){
                        dodaj[n-2] += 1;
                        resenje[last] = 0;
                    }else{
                        dodaj[n-2] += resenje[n-1];
                        resenje[last] = 0;
                    }
                }else{
                    switch(resenje[i] % 2){
                        case 0:{
                            dodaj[i-1] += resenje[i]/2;
                            dodaj[i+1] += resenje[i]/2;
                            resenje[i] = 0;
                            break;
                        }
                        case 1:{
                            if((brojReda+1) % 2 == 0){
                                dodaj[i+1] += resenje[i]/2 + 1;
                                dodaj[i-1] += resenje[i]/2;
                                resenje[i] = 0;
                            }else{
                                dodaj[i+1] += resenje[i]/2;
                                dodaj[i-1] += resenje[i]/2 + 1;
                                resenje[i] = 0;
                            }
                            break;
                        }
                    }
                }
            }
        }
        for(int i = 0; i < n; i++){
            resenje[i] += dodaj[i];
        }
    }

    for(int k = 0; k < n; k++){
        cout << resenje[k] << endl;
    }
}